/*
 *  Box.cpp
 *  visualizer2
 *
 *  Created by Mark Watson on Tue Apr 06 2004.
 *  Copyright (c) 2004 University of Saskatchewan. All rights reserved.
 *
 */

#include "Box.h"

Box::Box(float width, float height, float depth) : _width(width), _height(height), _depth(depth), _children1(0), _children2(0), _children3(0), _children4(0), _children5(0), _children6(0){};

Box::~Box(){};

void Box::draw_self() {
	glBegin(GL_QUADS);					// Draw A Quad
		glColor3f(0.0f,1.0f,0.0f);		// Set The Color To Green
		glVertex3f(_width, 0,-_depth);  // Top Right Of The Quad (Top)
		glVertex3f(0, 0,-_depth);		// Top Left Of The Quad (Top)
		glVertex3f(0, 0,0);				// Bottom Left Of The Quad (Top)
		glVertex3f(_width, 0, 0);		// Bottom Right Of The Quad (Top)
		glColor3f(1.0f,0.5f,0.0f);		// Set The Color To Orange
		glVertex3f(_width, -_height, 0);// Top Right Of The Quad (Bottom)
		glVertex3f(0, -_height, 0);		// Top Left Of The Quad (Bottom)
		glVertex3f(0, -_height, -_depth);		// Bottom Left Of The Quad (Bottom)
		glVertex3f(_width, -_height, -_depth);  // Bottom Right Of The Quad (Bottom)
		glColor3f(1.0f,0.0f,0.0f);		// Set The Color To Red
		glVertex3f(_width, 0, 0);		// Top Right Of The Quad (Front)
		glVertex3f(0, 0,0);				// Top Left Of The Quad (Front)
		glVertex3f(0, -_height, 0);		// Bottom Left Of The Quad (Front)
		glVertex3f(_width, -_height, 0);// Bottom Right Of The Quad (Front)
		glColor3f(1.0f,1.0f,0.0f);		// Set The Color To Yellow
		glVertex3f(_width, -_height, -_depth);  // Top Right Of The Quad (Back)
		glVertex3f(0, -_height, -_depth);		// Top Left Of The Quad (Back)
		glVertex3f(0, 0,-_depth);		// Bottom Left Of The Quad (Back)
		glVertex3f(_width, 0,-_depth);  // Bottom Right Of The Quad (Back)
		glColor3f(0.0f,0.0f,1.0f);		// Set The Color To Blue
		glVertex3f(0, 0,0);				// Top Right Of The Quad (Left)
		glVertex3f(0, 0,-_depth);		// Top Left Of The Quad (Left)
		glVertex3f(0, -_height, -_depth);		// Bottom Left Of The Quad (Left)
		glVertex3f(0, -_height, 0);		// Bottom Right Of The Quad (Left)
		glColor3f(1.0f,0.0f,1.0f);		// Set The Color To Violet
		glVertex3f(_width, 0,-_depth);  // Top Right Of The Quad (Right)
		glVertex3f(_width, 0, 0);		// Top Left Of The Quad (Right)
		glVertex3f(_width, -_height, 0);		// Bottom Left Of The Quad (Right)
		glVertex3f(_width, -_height, -_depth);  // Bottom Right Of The Quad (Right)
	glEnd();							// Done Drawing The Quad
	
	/* we do a bunch of fancy rotations and translations so everything draws correctly.*/
	

	
	//do face 1
	glPushMatrix();
	glTranslatef(0, 0, -_depth);
	glRotatef(90.,1.,0.,0.);
	glRotatef(180,0.,0.,1.);
	for( int i = 0; i < _children1 ; i++){
		glPushMatrix();

		glTranslatef(-_face1[i]->get_gel()->get_width(), 0., 0.);
		glTranslatef(_face1[i]->get_x(),_face1[i]->get_y(),_face1[i]->get_z());
		glRotatef( _face1[i]->get_roll(), 1., 0., 0.);
		glRotatef( _face1[i]->get_pitch(), 0., 1., 0.);
		glRotatef( _face1[i]->get_yaw(), 0., 0., 1.);
		_face1[i]->get_gel()->draw_self();
		glPopMatrix();
	}
	glPopMatrix();

	//do face 2
	glPushMatrix();
    glRotatef(180.,0.,1.,0.);
	for( int i = 0; i < _children2; i++){
		glPushMatrix();
		glTranslatef(-_face2[i]->get_gel()->get_width(), 0., 0.);
		glTranslatef(_face2[i]->get_x(),_face2[i]->get_y(),_face2[i]->get_z());
		glRotatef( _face2[i]->get_roll(), 1., 0., 0.);
		glRotatef( _face2[i]->get_pitch(), 0., 1., 0.);
		glRotatef( _face2[i]->get_yaw(), 0., 0., 1.);
		_face2[i]->get_gel()->draw_self();
		//glPopMatrix();
		glPopMatrix();
	}
	glPopMatrix();


	//do face 3
	glPushMatrix();
	glTranslatef(0, -_height, 0);
	glRotatef(90.,1.,0.,0.);
	glRotatef(180.,0.,1.,0.);
	for( int i = 0; i < _children3 ; i++){
		glPushMatrix();
		glTranslatef(-_face3[i]->get_gel()->get_width(), 0., 0.);
		glTranslatef(_face3[i]->get_x(),_face3[i]->get_y(),_face3[i]->get_z());
		glRotatef( _face3[i]->get_roll(), 1., 0., 0.);
		glRotatef( _face3[i]->get_pitch(), 0., 1., 0.);
		glRotatef( _face3[i]->get_yaw(), 0., 0., 1.);
		_face3[i]->get_gel()->draw_self();
		glPopMatrix();
	}
	glPopMatrix();



	//do face 4
	glPushMatrix();
	glTranslatef(0., -_height, -_depth);
	glRotatef(180.,0.,0.,1.);
	for( int i = 0; i < _children4 ; i++){
		glPushMatrix();
		glTranslatef(-_face4[i]->get_gel()->get_width(), 0., 0.);
		glTranslatef(_face4[i]->get_x(),_face4[i]->get_y(),_face4[i]->get_z());
		glRotatef( _face4[i]->get_roll(), 1., 0., 0.);
		glRotatef( _face4[i]->get_pitch(), 0., 1., 0.);
		glRotatef( _face4[i]->get_yaw(), 0., 0., 1.);
		_face4[i]->get_gel()->draw_self();
		glPopMatrix();
	}
	glPopMatrix();



	//do face 5
	glPushMatrix();
	glTranslatef(0, 0, -_depth);
	glRotatef(90.,0.,1.,0.);
	for( int i = 0; i < _children5 ; i++){
		glPushMatrix();
		glTranslatef(-_face5[i]->get_gel()->get_width(), 0., 0.);
		glTranslatef(_face5[i]->get_x(),_face5[i]->get_y(),_face5[i]->get_z());
		glRotatef( _face5[i]->get_roll(), 1., 0., 0.);
		glRotatef( _face5[i]->get_pitch(), 0., 1., 0.);
		glRotatef( _face5[i]->get_yaw(), 0., 0., 1.);
		_face5[i]->get_gel()->draw_self();
		glPopMatrix();
	}
	glPopMatrix();



	//do face 6
	glPushMatrix();
	glTranslatef(_width, 0, 0);
	glRotatef(-90.,0.,1.,0.);
	for( int i = 0; i < _children6 ; i++){
		glPushMatrix();
		glTranslatef(-_face6[i]->get_gel()->get_width(), 0., 0.);
		glTranslatef(_face6[i]->get_x(),_face6[i]->get_y(),_face6[i]->get_z());
		glRotatef( _face6[i]->get_roll(), 1., 0., 0.);
		glRotatef( _face6[i]->get_pitch(), 0., 1., 0.);
		glRotatef( _face6[i]->get_yaw(), 0., 0., 1.);
		_face6[i]->get_gel()->draw_self();
		glPopMatrix();
	}
	glPopMatrix();



    glFlush();
};

void Box::add_to_face(Pin* p, int face) {
	switch(face) {
		case 1:
			_face1[_children1] = p;
			_children1++;
			break;
		case 2:
			_face2[_children2] = p;
			_children2++;
			break;
		case 3:
			_face3[_children3] = p;
			_children3++;
			break;
		case 4:
			_face4[_children4] = p;
			_children4++;
			break;
		case 5:
			_face5[_children5] = p;
			_children5++;
			break;
		case 6:
			_face6[_children6] = p;
			_children6++;
			break;
	}
};

float Box::get_height() { 
	return _height;
};
float Box::get_width() { 
	return _width;
};
float Box::get_depth() { 
	return _depth;
};
