/*
 *  Box.h
 *  visualizer2
 *
 *  Created by Mark Watson on Tue Apr 06 2004.
 *  Copyright (c) 2004 University of Saskatchewan. All rights reserved.
 *
 * A class that represents boxes.  Boxes can have other gels on their surface.
 */


#include "Primaries.h"

#ifndef BOX_H
#define BOX_H

class Box : public Gel {
public:
	// create the box
	Box(float width = 10., float height = 10., float depth = 10.);
	~Box();
	
	// draw box and children
	void draw_self();
	void add_to_face(Pin* p, int face);
	float get_height();
	float get_width();
	float get_depth();
protected:
	float _width;
	float _height;
	float _depth;
	Pin* _face1[100];
	Pin* _face2[100];
	Pin* _face3[100];
	Pin* _face4[100];
	Pin* _face5[100];
	Pin* _face6[100];
	int _children1, _children2, _children3, _children4, _children5, _children6;
};

#endif