/*
 *  Pin.h
 *  Visualizer
 *
 *  Created by Mark Watson.
 *  Copyright (c) 2004 University of Saskatchewan. All rights reserved.
 *
 *  Contains 2 classes:  Gel, the class from which all gels inherit and Pin, the class
 *  which holds all gels.
 *
 */


#ifdef WIN32
#include <gl\glut.h>
#else
#include <GLUT/glut.h>
#endif
using namespace std;

#ifndef PRIMARIES_H
#define PRIMARIES_H

class Pin;
class Gel {
public:
	Gel();
    virtual ~Gel();
    virtual void draw_self();
	virtual float get_height();
	virtual float get_width();
	virtual float get_depth();
	virtual void add_to_face(Pin* p, int i);
protected:
	float _width;
	float _height;
	float _depth;
    int _num_children;
};

class Pin {
public:
    Pin();
    Pin(float x, float y, float z, Gel* g);
    Pin(float x, float y, float z, float pitch, float yaw, float roll, Gel* g);
    ~Pin();
    float get_x();
    float get_y();
    float get_z();
	float get_yaw();
	float get_roll();
	float get_pitch();
    Gel* get_gel();
    void set_x(float x);
    void set_y(float y);
    void set_z(float z);
	void set_yaw(float yaw);
	void set_roll(float roll);
	void set_pitch(float pitch);	
    void set_gel(Gel* g);
private:
    float _x;
    float _y;
    float _z;
	float _pitch;
	float _yaw;
	float _roll;
	Gel* _gel;
};



#endif


